package com.liang.dao;

import com.liang.entity.BaseNation;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (BaseNation)表数据库访问层
 *
 * @author makejava
 * @since 2023-02-15 23:13:15
 */
public interface BaseNationDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    BaseNation queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param baseNation 查询条件
     * @param pageable   分页对象
     * @return 对象列表
     */
    List<BaseNation> queryAllByLimit(BaseNation baseNation, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param baseNation 查询条件
     * @return 总行数
     */
    long count(BaseNation baseNation);

    /**
     * 新增数据
     *
     * @param baseNation 实例对象
     * @return 影响行数
     */
    int insert(BaseNation baseNation);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseNation> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<BaseNation> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseNation> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<BaseNation> entities);

    /**
     * 修改数据
     *
     * @param baseNation 实例对象
     * @return 影响行数
     */
    int update(BaseNation baseNation);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 获取所有数据
     *
     * @return
     */
    List<BaseNation> queryAll();

    /**
     * 获取民族
     *
     * @return
     */
    List<Map<String, String>> getNation();

    /**
     * 获取民族列表
     *
     * @return
     */
    List<BaseNation> getNationList(Map map);
}

